-- Fairy Init

freeslot("MT_ACEFAIRY", "SPR_FIDL", "S_ACEFAIRY", "S_ACEFAIRY_COLLECT", "S_ACEFAIRY_POINT",
"MT_ACEFAIRY_BUBBLE", "S_ACEFAIRY_BUBBLE", "S_ACEFAIRY_BUBBLE_POP")

mobjinfo[MT_ACEFAIRY] =
{
	spawnstate = S_ACEFAIRY,
	deathstate = S_ACEFAIRY,
	spawnhealth = 3,
	radius = 15*FRACUNIT,
	height = 20*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_SHOOTABLE|MF_NOCLIPHEIGHT
}
states[S_ACEFAIRY] = {SPR_FIDL, A, -1, nil, 0, 0, S_ACEFAIRY}
states[S_ACEFAIRY_COLLECT] = {SPR_FIDL, A, -1, nil, 0, 0, S_ACEFAIRY}
states[S_ACEFAIRY_POINT] = {SPR_FIDL, A, 10, nil, 0, 0, S_ACEFAIRY}

mobjinfo[MT_ACEFAIRY_BUBBLE] =
{
	spawnstate = S_ACEFAIRY_BUBBLE,
	deathstate = S_ACEFAIRY_BUBBLE_POP,
	spawnhealth = 1,
	radius = 15*FRACUNIT,
	height = 20*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPHEIGHT
}
states[S_ACEFAIRY_BUBBLE] = {SPR_BUBS, K, -1, nil, 0, 0}
states[S_ACEFAIRY_BUBBLE_POP] = {SPR_BUBS, 0, 0, nil, 0, 0, S_NULL}

-- Fairy Setup

addHook("ThinkFrame", function()
	for player in players.iterate
		if player.realmo and ((player.realmo.skin == "ace" and player.wiz)
		or (player.realmo.skin != "ace" and player.wizlite))
			if player.acefairy and player.acefairy.valid and player.acefairy.target
				
				-- Movement
				
				if player.acefairy.health
					if player.acefairy.tracer and player.acefairy.tracer.valid
					and player.acefairy.state != S_ACEFAIRY_POINT
						player.acefairy.newx = player.acefairy.tracer.x
						player.acefairy.sidex = 0
						player.acefairy.newy = player.acefairy.tracer.y
						player.acefairy.sidey = 0
						player.acefairy.newz = player.acefairy.tracer.z
						
						player.acefairy.angle = R_PointToAngle2(player.acefairy.x, player.acefairy.y, player.acefairy.tracer.x, player.acefairy.tracer.y)
					/*elseif player.acefairy.point and player.acefairy.point.valid
					and player.acefairy.state == S_ACEFAIRY_POINT
						player.acefairy.newx = min(player.acefairy.point.x - player.acefairy.target.x, player.acefairy.target.x + 512*player.acefairy.target.scale)
						player.acefairy.sidex = 0
						player.acefairy.newy = min(player.acefairy.point.y - player.acefairy.target.y, player.acefairy.target.y + 512*player.acefairy.target.scale)
						player.acefairy.sidey = 0
						player.acefairy.newz = min(player.acefairy.point.z - player.acefairy.target.z, player.acefairy.target.z + 512*player.acefairy.target.scale)
						
						player.acefairy.angle = R_PointToAngle2(player.acefairy.x, player.acefairy.y, player.acefairy.point.x, player.acefairy.point.y)*/
					else
						player.acefairy.newx = player.acefairy.target.x - player.acefairy.target.player.rmomx + FixedMul(cos(player.acefairy.target.player.drawangle), player.acefairy.target.radius - player.acefairy.radius - 50*FRACUNIT)
						player.acefairy.newy = player.acefairy.target.y - player.acefairy.target.player.rmomy + FixedMul(sin(player.acefairy.target.player.drawangle), player.acefairy.target.radius - player.acefairy.radius - 50*FRACUNIT)
						
						if not (player.acefairy.eflags & MFE_VERTICALFLIP)
							player.acefairy.newz = player.acefairy.target.z - player.acefairy.target.momz + player.acefairy.target.height
						else
							player.acefairy.newz = player.acefairy.target.z + player.acefairy.target.momz - player.acefairy.height
						end
						
						if player.playerstate == PST_LIVE and not (player.acefairy.target.flags2 & MF2_TWOD)
						and player.powers[pw_carry] != CR_NIGHTSMODE and player.powers[pw_carry] != CR_ZOOMTUBE
							if leveltime % (12*TICRATE) == 0
								player.acefairy.side = P_RandomChance(FRACUNIT/2) and -1 or 1
							end
							
							player.acefairy.sidex = ease.inoutsine(1*FRACUNIT/12, player.acefairy.sidex, P_ReturnThrustX(player.acefairy, player.acefairy.angle - ANGLE_90 * player.acefairy.side, FixedMul(50*FRACUNIT, player.acefairy.target.scale)))
							player.acefairy.sidey = ease.inoutsine(1*FRACUNIT/12, player.acefairy.sidey, P_ReturnThrustY(player.acefairy, player.acefairy.angle - ANGLE_90 * player.acefairy.side, FixedMul(50*FRACUNIT, player.acefairy.target.scale)))
						else
							player.acefairy.sidex = 0
							player.acefairy.sidey = 0
						end
						
						player.acefairy.angle = player.acefairy.target.player.drawangle
					end
				else
					player.acefairy.newx = player.acefairy.target.x + FixedMul(cos(player.acefairy.target.player.drawangle), player.acefairy.target.radius - player.acefairy.radius)
					player.acefairy.newy = player.acefairy.target.y + FixedMul(sin(player.acefairy.target.player.drawangle), player.acefairy.target.radius - player.acefairy.radius)
					
					if not (player.acefairy.eflags & MFE_VERTICALFLIP)
						player.acefairy.newz = player.acefairy.target.z + player.acefairy.target.height
					else
						player.acefairy.newz = player.acefairy.target.z - player.acefairy.height
					end
					
					player.acefairy.sidex = 0
					player.acefairy.sidey = 0
					
					player.acefairy.angle = player.acefairy.target.player.drawangle
				end
				
				-- Find
				
				/*if player.ytap and player.playerstate == PST_LIVE
				and not P_PlayerInPain(player) and player.mo.state != S_PLAY_ROLL
					if player.acefairy.point and player.acefairy.point.valid
						if player.acefairy.state != S_ACEFAIRY_POINT
							player.acefairy.state = S_ACEFAIRY_POINT
						end
					//else
						
					end
				end*/
				
				-- Shield
				
				local LT = BT_CUSTOM1
				local player = player.acefairy.target.player
				
				if player.wiz
					player.wiz.parry = player.wiz.parrytime > 0
					player.wiz.parrytime = max($-1, 0)
					
					if (player.cmd.buttons & LT) and player.playerstate == PST_LIVE
					and not P_PlayerInPain(player) and player.mo.state != S_PLAY_ROLL
					and not player.wiz.jumpability and not player.wiz.twistability
					and not player.wiz.shieldrecharge and not player.wiz.shielddelay
					and not player.wiz.casting and not player.gotflag
					or player.playerstate == PST_LIVE and (player.mo.state != S_PLAY_PAIN
					or (player.pflags & PF_SLIDING)) and player.powers[pw_flashing]
						if player.wiz.shieldtime > 0
							player.wiz.shield = true
							player.wiz.shieldtime = $-1
							
							if not player.wiz.shieldorb or not player.wiz.shieldorb.valid
								if player.lttap
									player.wiz.parrytime = 2
								end
								
								player.wiz.shieldorb = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_ACESHIELD)
								player.wiz.shieldorb.target = player.mo
								S_StartSound(mobj, sfx_shield)
							end
						else
							player.wiz.shieldrecharge = true
						end
					else
						if player.wiz.shield
							player.wiz.shield = false
							player.wiz.shielddelay = 15
						end
						
						player.wiz.shieldtime = min($+1, 100)
						
						if player.wiz.shieldorb and player.wiz.shieldorb.valid
							P_RemoveMobj(player.wiz.shieldorb)
							S_StartSound(mobj, sfx_ngskid)
						end
					end
					
					if player.lttap and player.wiz.shieldrecharge
						player.wiz.shieldrecharge = false
					end
					
					player.wiz.shielddelay = max($-1, 0)
				end
				
				-- Shield Lite
				
				/*if player.wizlite
					player.wizlite.parry = player.wizlite.parrytime > 0
					player.wizlite.parrytime = max($-1, 0)
					
					if (player.cmd.buttons & LT) and player.playerstate == PST_LIVE
					and not P_PlayerInPain(player) and player.mo.state != S_PLAY_ROLL
					and not player.wizlite.shieldrecharge and not player.gotflag
					or player.playerstate == PST_LIVE and (player.mo.state != S_PLAY_PAIN
					or (player.pflags & PF_SLIDING)) and player.powers[pw_flashing]
						if player.wizlite.shieldtime > 0
							player.wizlite.shield = true
							player.wizlite.shieldtime = $-1
							
							if player.lttap and not player.powers[pw_flashing]
								player.wizlite.parrytime = 2
							end
							
							if not player.wizlite.shieldorb or not player.wizlite.shieldorb.valid
								player.wizlite.shieldorb = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_ACESHIELD)
								player.wizlite.shieldorb.target = player.mo
							end
						else
							player.wizlite.shieldrecharge = true
						end
					else
						player.wizlite.shield = false
						player.wizlite.shieldtime = min($+1, 100)
						
						if player.wizlite.shieldorb and player.wizlite.shieldorb.valid
							P_RemoveMobj(player.wizlite.shieldorb)
						end
					end
					
					if player.lttap and player.wizlite.shieldrecharge
						player.wizlite.shieldrecharge = false
					end
				end*/
			else
				player.acefairy = P_SpawnMobjFromMobj(player.mo,
				player.rmomx + FixedMul(cos(player.drawangle), player.mo.radius - mobjinfo[MT_ACEFAIRY].radius - 50*FRACUNIT)
				+ P_ReturnThrustX(mobj, player.drawangle - ANGLE_90, FixedMul(50*FRACUNIT, player.mo.scale)),
				player.rmomy + FixedMul(sin(player.drawangle), player.mo.radius - mobjinfo[MT_ACEFAIRY].radius - 50*FRACUNIT)
				+ P_ReturnThrustY(mobj, player.drawangle - ANGLE_90, FixedMul(50*FRACUNIT, player.mo.scale)),
				player.mo.momz + player.mo.height, MT_ACEFAIRY)
				
				if player.realmo
					player.acefairy.target = player.mo
				end
				
				player.acefairy.newx = player.acefairy.x
				player.acefairy.newy = player.acefairy.y
				player.acefairy.newz = player.acefairy.z
				
				player.acefairy.side = -1
				
				player.acefairy.sidex = P_ReturnThrustX(player.acefairy, player.acefairy.angle - ANGLE_90, FixedMul(50*FRACUNIT, player.acefairy.target.scale))
				player.acefairy.sidey = P_ReturnThrustY(player.acefairy, player.acefairy.angle - ANGLE_90, FixedMul(50*FRACUNIT, player.acefairy.target.scale))
			end
		end
	end
end)

-- Fairy Thinker

addHook("MobjThinker", function(mobj)
	for player in players.iterate
		if player.mo and mobj.valid
			if mobj.target != nil and ((mobj.target.skin == "ace" and mobj.target.player.wiz)
			or (mobj.target.skin != "ace" and mobj.target.player.wizlite))
				if not G_GametypeHasTeams()
					mobj.color = R_GetColorByName(mobj.target.color+21)
				else
					mobj.color = R_GetColorByName(mobj.target.color)
				end
				
				if mobj.target.player.playerstate != PST_DEAD
					if mobj.health
						mobj.movedir = $ + FixedAngle(8*FRACUNIT)
					
						P_MoveOrigin(mobj,
						ease.inoutsine(1*FRACUNIT/3, mobj.x, mobj.newx + mobj.sidex),
						ease.inoutsine(1*FRACUNIT/3, mobj.y, mobj.newy + mobj.sidey),
						ease.inoutsine(1*FRACUNIT/3, mobj.z, mobj.newz)
						+ FixedMul(cos(mobj.movedir), 1*FRACUNIT/2))
						
						mobj.frame = $|FF_FULLBRIGHT
					else
						mobj.movedir = 0
						
						P_MoveOrigin(mobj, mobj.newx, mobj.newy, mobj.newz)
						
						mobj.frame = $&~FF_FULLBRIGHT
					end
				else
					if not (mobj.flags & MF_NOCLIP)
						mobj.flags = MF_NOCLIP|MF_NOCLIPHEIGHT
						P_SetObjectMomZ(mobj, mobj.target.momz)
					end
					
					mobj.frame = $&~FF_FULLBRIGHT
				end
				
				if P_MobjFlip(mobj.target) > 0
					mobj.flags2 = $&~MF2_OBJECTFLIP
					mobj.eflags = $&~MFE_VERTICALFLIP
				else
					mobj.flags2 = $|MF2_OBJECTFLIP
					mobj.eflags = $|MFE_VERTICALFLIP
				end
				
				mobj.scale = mobj.target.scale
				
				if (mobj.eflags & MFE_UNDERWATER)
					if not (mobj.bubble and mobj.bubble.valid)
						mobj.bubble = P_SpawnMobjFromMobj(mobj, 0, 0, 0, MT_ACEFAIRY_BUBBLE)
						mobj.bubble.target = mobj
					else
						A_CapeChase(mobj.bubble)
					end
				else
					if mobj.bubble and mobj.bubble.valid
						P_KillMobj(mobj.bubble)
					end
				end
			else
				P_KillMobj(mobj)
			end
		end
	end
end, MT_ACEFAIRY)

addHook("ShouldDamage", function(target, inflictor, source, damage, damagetype)
	if target and target.valid
		return false
	end
end, MT_ACEFAIRY)

-- Fariy Collect

local function FariyCollect(mobj, collectible)
	if mobj and mobj.valid and mobj.target and mobj.target.valid
	and collectible and collectible.valid
	and (ARTH_Ace.AceCollectible[collectible.type]
	and ARTH_Ace.AceCollectible[collectible.type][1])
		if mobj.tracer and collectible == mobj.tracer
		and (mobj.z <= collectible.z + collectible.height and mobj.z + mobj.height >= collectible.z)
		and collectible.health and not collectible.collected
			mobj.tracer = nil
			
			collectible.collected = true
			collectible.target = mobj.target
			collectible.flags = $|MF_NOCLIP|MF_NOCLIPHEIGHT
			S_StartSound(mobj, sfx_thok)
			return false
		end
	end
end

addHook("MobjCollide", FariyCollect, MT_ACEFAIRY)
addHook("MobjMoveCollide", FariyCollect, MT_ACEFAIRY)

local function CollectibleThinker(collectible)
	if not collectible or not collectible.valid
	or not collectible.health
		return
	end
	
	if collectible and collectible.valid and ARTH_Ace.AceCollectible[collectible.type]
		for player in players.iterate
			
			-- Tracker
			
			if ARTH_Ace.AceCollectible[collectible.type][1]
				if player.acefairy and player.acefairy.valid
				and player.acefairy.target and player.acefairy.target.valid
					local dist1 = P_AproxDistance(P_AproxDistance(collectible.x - player.acefairy.target.x, collectible.y - player.acefairy.target.y), collectible.z - player.acefairy.target.z)
					local dist2 = P_AproxDistance(P_AproxDistance(player.acefairy.x - collectible.x, player.acefairy.y - collectible.y), player.acefairy.z - collectible.z)
					local dist3 = P_AproxDistance(P_AproxDistance(player.acefairy.x - player.acefairy.target.x, player.acefairy.y - player.acefairy.target.y), player.acefairy.z - player.acefairy.target.z)
					
					if (dist1 >= 0 and dist1 < 512*player.acefairy.target.scale)
						if not player.acefairy.tracer and P_CheckSight(player.mo, collectible)
						and not P_PlayerInPain(player.acefairy.target.player) and player.powers[pw_carry] != CR_NIGHTSMODE
						and not collectible.tracer and player.playerstate == PST_LIVE
							if ((dist1 >= 0 and dist1 < 256*player.acefairy.target.scale)
							or (dist2 >= 0 and dist2 < 128*player.acefairy.target.scale))
							and collectible.health and not collectible.collected
								player.acefairy.tracer = collectible
								player.acefairy.tracer.tracer = player.acefairy
							end
						elseif player.acefairy.tracer and (not P_CheckSight(player.mo, player.acefairy.tracer)
						or not (dist3 >= 0 and dist3 < 512*player.acefairy.target.scale)
						or not player.acefairy.tracer.health or player.acefairy.tracer.collected
						or P_PlayerInPain(player.acefairy.target.player) or player.playerstate != PST_LIVE)
							player.acefairy.tracer = nil
						end
					end
				end
				
				if collectible.target and collectible.collected
					A_HomingChase(collectible, 30*FRACUNIT+collectible.target.player.speed)
					
					if not collectible.health
						collectible.collected = false
						collectible.target = nil
						collectible.tracer = nil
					end
				end
			end
			
			if ARTH_Ace.AceCollectible[collectible.type][2]
				if player.acefairy and player.acefairy.valid
				and player.acefairy.target and player.acefairy.target.valid
					local dist1 = P_AproxDistance(P_AproxDistance(collectible.x - player.acefairy.target.x, collectible.y - player.acefairy.target.y), collectible.z - player.acefairy.target.z)
					local dist2 = P_AproxDistance(P_AproxDistance(collectible.x - player.acefairy.target.x, collectible.y - player.acefairy.target.y), collectible.z - player.acefairy.target.z)
					
					if (dist1 >= 0 and dist1 < dist2)
						if not player.acefairy.tracer and P_CheckSight(player.mo, collectible)
						and not P_PlayerInPain(player.acefairy.target.player) and player.powers[pw_carry] != CR_NIGHTSMODE
						and not collectible.tracer and player.playerstate == PST_LIVE
							if collectible.health and not collectible.collected
								player.acefairy.point = collectible
							end
						elseif player.acefairy.tracer and (not P_CheckSight(player.mo, player.acefairy.tracer)
						or not player.acefairy.tracer.health or player.acefairy.tracer.collected
						or P_PlayerInPain(player.acefairy.target.player) or player.playerstate != PST_LIVE)
							player.acefairy.point = nil
						end
					end
				end
			end
		end
	end
end

addHook("MobjThinker", CollectibleThinker)

-- Shield Behavior

addHook("MobjThinker", function(shield)
	for player in players.iterate
		if shield and shield.valid
		and player.mo and shield.target == player.mo
			local ShieldZ
			if P_MobjFlip(shield.target) > 0
				ShieldZ = player.mo.z + 2*FRACUNIT
				
				shield.flags2 = $&~MF2_OBJECTFLIP
				shield.eflags = $&~MFE_VERTICALFLIP
			else
				ShieldZ = player.mo.z - 2*FRACUNIT
				
				shield.flags2 = $|MF2_OBJECTFLIP
				shield.eflags = $|MFE_VERTICALFLIP
			end
			
			P_MoveOrigin(shield, player.mo.x, player.mo.y, ShieldZ)
			
			shield.angle = player.drawangle
			shield.scale = player.shieldscale
		end
	end
end, MT_ACESHIELD)

local function ShieldCollide(shield, mobj)
	if not (mobj and mobj.valid and shield and shield.valid)
	or not ((mobj.flags & MF_ENEMY) /*or (mobj.flags & MF_MISSILE)
	or (mobj.flags & MF_PAIN)*/ or (mobj.flags & MF_PUSHABLE))
	or shield.target == mobj //or mobj.fromace
		return
	end
	
	if mobj.z - mobj.scale <= shield.z + shield.height
	and mobj.z + mobj.height + mobj.scale >= shield.z
		local PushAngle = R_PointToAngle2(shield.target.x, shield.target.y, mobj.x, mobj.y)
		
		if shield.target.player.wiz.parry
			/*if (mobj.flags & MF_MISSILE) or (mobj.flags & MF_PAIN)
				local Momz = mobj.momz
				local Missile = mobj.type
				
				if mobj.health
					mobj.target = nil
					mobj.state = mobjinfo[Missile].spawnstate
					
					P_InstaThrust(mobj, PushAngle, mobj.info.speed)
					mobj.momz = -Momz
				else
					local mobj = P_SPMAngle(shield, Missile, PushAngle)
					mobj.momz = -Momz
					mobj.fromace = true
				end
				
				-- TODO: Reverse mace speed
				
				if not shield.parried
					S_StartSound(shield, sfx_hoop2)
					shield.parried = true
				end
				
				shield.target.player.wiz.parrytime = 2
				shield.target.player.wiz.shieldtime = $+2
			end*/
			
			if (mobj.flags & MF_ENEMY) or (mobj.flags & MF_PUSHABLE)
				P_InstaThrust(mobj, PushAngle, mobjinfo[mobj.type].speed*8*FRACUNIT)
			end
			
			S_StartSound(shield, sfx_s259)
		else
			/*if shield.parried
				shield.parried = false
			end
			
			if (mobj.flags & MF_MISSILE)
				P_DamageMobj(mobj)
			end*/
			
			if (mobj.flags & MF_ENEMY) or (mobj.flags & MF_PUSHABLE)
				P_InstaThrust(mobj, PushAngle, shield.target.player.speed+PUSHACCEL)
			end
		end
	end
end

addHook("MobjCollide", ShieldCollide, MT_ACESHIELD)
addHook("MobjMoveCollide", ShieldCollide, MT_ACESHIELD)

-- Give players a fairy (WIP)

/*local function PrintMsg(var)
	for player in players.iterate
		if player.realmo
			if var == 1
				CONS_Printf(player, "\x89\They now have a fairy.")
			elseif var == 2
				CONS_Printf(player, "\x89\They do not have a fairy anymore.")
			elseif var == 3
				CONS_Printf(player, "\x89\They already have a fairy.")
			end
			
			return
		end
	end
end

COM_AddCommand("GiveFairy", function(player, arg)
	for player in players.iterate
		if not splitscreen
			if arg == "help"
				CONS_Printf(player, "\x89\A fairy can help you collect and find collectibles and can give you a shield.")
				CONS_Printf(player, "\x89\You can give yourself and a bot a fairy. You can give a bot a fairy if you type 'bot', 'ai' or their skin name beside the command.")
			elseif not player.bot and (arg != "bot" and arg != "ai" and arg != (player.bot and player.mo.skin))
				if player.mo.skin != "ace" and not player.wizlite
					player.wizlite =
					{shield = false,
					shieldtime = 100,
					shieldrecharge = false,
					parry = false,
					parrytime = 0}
					
					CONS_Printf(player, "\x89\You now have a fairy.")
				elseif player.mo.skin != "ace" and player.wizlite
					player.wizlite = nil
					
					CONS_Printf(player, "\x89\You do not have a fairy anymore.")
				else
					CONS_Printf(player, "\x89\You already have a fairy.")
				end
			elseif player.bot and (arg == "bot" or arg == "ai" or arg == player.mo.skin)
				if player.bot and player.mo.skin != "ace" and not player.wizlite
					player.wizlite =
					{shield = false,
					shieldtime = 100,
					shieldrecharge = false,
					parry = false,
					parrytime = 0}
					
					PrintMsg(1)
				elseif player.bot and player.mo.skin != "ace" and player.wizlite
					player.wizlite = nil
					
					PrintMsg(2)
				elseif player.bot and player.mo.skin == "ace"
					PrintMsg(3)
				end
			elseif not player.bot and (arg == "bot" or arg == "ai" or arg == player.mo.skin)
				CONS_Printf(player, "\x89\There is no bot.")
			end
		else
			CONS_Printf(player, "\x89\This does not support 2 player")
		end
	end
end)*/