-- Tables

---- Collectibles collectable by the fairy

/*ARTH_Ace.AceCollectible[name] = {collectable, pointable}

name: -- The name of the collectible.
collectable: -- If true, the fairy will collect it. If false, the fairy won't collect it.
pointable: -- If true, the fairy will point at it. If false, the fairy won't point at it.*/

if not ARTH_Ace.AceCollectible
	rawset(ARTH_Ace, "AceCollectible", {})
end
ARTH_Ace.AceCollectible[MT_RING] = {true, false}
ARTH_Ace.AceCollectible[MT_FLINGRING] = {true, false}
ARTH_Ace.AceCollectible[MT_COIN] = {true, false}
ARTH_Ace.AceCollectible[MT_FLINGCOIN] = {true, false}
ARTH_Ace.AceCollectible[MT_TOKEN] = {true, true}
ARTH_Ace.AceCollectible[MT_BLUESPHERE] = {true, true}
addHook("ThinkFrame", function(player)
	if splitscreen return end
	
	for player in players.iterate
		if player.realmo
			if player.ctfteam == 1
				ARTH_Ace.AceCollectible[MT_REDTEAMRING] = {true, false}
				ARTH_Ace.AceCollectible[MT_BLUETEAMRING] = {false, false}
			elseif player.ctfteam == 2
				ARTH_Ace.AceCollectible[MT_REDTEAMRING] = {false, false}
				ARTH_Ace.AceCollectible[MT_BLUETEAMRING] = {true, false}
			else
				ARTH_Ace.AceCollectible[MT_REDTEAMRING] = {false, false}
				ARTH_Ace.AceCollectible[MT_BLUETEAMRING] = {false, false}
			end
			
			if (gametyperules & GTR_TEAMFLAGS)
				ARTH_Ace.AceCollectible[MT_REDFLAG] = {false, true}
				ARTH_Ace.AceCollectible[MT_BLUEFLAG] = {false, true}
			else
				ARTH_Ace.AceCollectible[MT_REDFLAG] = {false, false}
				ARTH_Ace.AceCollectible[MT_BLUEFLAG] = {false, false}
			end
		end
	end
end)
ARTH_Ace.AceCollectible[MT_EMBLEM] = {false, true}
ARTH_Ace.AceCollectible[MT_EMERALD1] = {false, true}
ARTH_Ace.AceCollectible[MT_EMERALD2] = {false, true}
ARTH_Ace.AceCollectible[MT_EMERALD3] = {false, true}
ARTH_Ace.AceCollectible[MT_EMERALD4] = {false, true}
ARTH_Ace.AceCollectible[MT_EMERALD5] = {false, true}
ARTH_Ace.AceCollectible[MT_EMERALD6] = {false, true}
ARTH_Ace.AceCollectible[MT_EMERALD7] = {false, true}
ARTH_Ace.AceCollectible[MT_EMERHUNT] = {false, true}

-- Functions

---- Healing for Ace's Health System

/*ARTH_Ace.AceHeal(player, sound)

player: -- The player.
sound: -- If true or nil, it will play the healing sound. If false, it won't play the healing sound.*/

if not ARTH_Ace.AceHeal
	rawset(ARTH_Ace, "AceHeal", function(player, sound) 
		if player and player.valid
		and player.acefairy and player.acefairy.valid
		and player.acefairy.target.skin == "ace"
		and player.powers[pw_carry] != CR_NIGHTSMODE
		and player.powers[pw_carry] != CR_NIGHTSFALL
			if player.acefairy.health < 4
				player.acefairy.health = $+1
				
				if sound != false
					S_StartSound(special, sfx_hoop1)
				end
			end
		end
	end)
end

/*ARTH_Ace.SpawnFlower(mobj, player, target)

mobj: -- The object you're spawning the flower from.
player: -- The player.
target: -- If true, it will home in on the player. If false or nil, it won't home in on the player.*/

if not ARTH_Ace.SpawnFlower
	rawset(ARTH_Ace, "SpawnFlower", function(mobj, player, target)
		local Flower = P_SpawnMobj(mobj.x, mobj.y, mobj.z, MT_ACEFLOWER)
				
		if player.acefairy.health == 4
			Flower.flags = $&~MF_SPECIAL
		end
		
		if P_MobjFlip(mobj) > 0
			Flower.flags2 = $&~MF2_OBJECTFLIP
			Flower.eflags = $&~MFE_VERTICALFLIP
		else
			Flower.flags2 = $|MF2_OBJECTFLIP
			Flower.eflags = $|MFE_VERTICALFLIP
		end
		
		if target
			Flower.target = player.mo
		end
	end)
end

-- Commands

---- Ace's Health System

if not ARTH_Ace.AceHealth
	rawset(ARTH_Ace, "AceHealth", CV_RegisterVar({
		name = "acehealth",
		defaultvalue = "On",
		flags = CV_NETVAR|CV_CALL|CV_NOINIT,
		PossibleValue = CV_OnOff,
		func = function(cv)
			if cv.value
				print("\x84\Ace's Health System is on.")
			else
				print("\x84\Ace's Health System is off.")
			end
		end
	}))
end